<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?php
class Core_Language {
	private static $instance = false;
	
	protected $DB;
	protected $Session;
	protected $Config;
	protected $ErrorLog;
	
	public $static_array=array();
	public $lang_array=array();
	public $lang_t_array=array();
	
	private $default_language = '';
	private $current_language;
	public $lang_key = 'original';
	
	private $lastError = 0;
	
	const err_no_lang_code = 'LANGUAGE_ERR_NO_LANG_CODE';
	const err_no_lang_name = 'LANGUAGE_ERR_NO_LANG_NAME';
	const err_incorrect_code_len = 'LANGUAGE_ERR_INCORRECT_CODE_LEN';
	const err_code_exists = 'LANGUAGE_ERR_CODE_EXISTS';
	const err_code_invalid = 'LANGUAGE_ERR_CODE_INVALID';
	
	private function __construct() {
	
		$this->DB = Core_Database::getInstance();
		$this->Session = Core_Session::getInstance();
		$this->Config = Core_Config::getInstance();
		$this->ErrorLog = Core_ErrorLog::getInstance();
		
		$def_lng = $this->Config->Get('DEFAULT_SITE_LANG');
		if ($def_lng) {
			$this->default_language = $def_lng;
		}
		
		$use_cookie = $this->Config->Get('REMEMBER_LAST_LANG');
		$cookie_lang = Tools_Http::getCookie ('lang');
		
		$list = explode('/',$_SERVER['REQUEST_URI']); 
        $langs = $this->getLanguageList();
        
        foreach($langs as $key => $lang) {
        
        	$existingLangs[$lang]=1;
        	
        }
		
		if (Tools_Http::Get('lang')) {
			$new_lang = substr(Tools_Text::cleanString(Tools_Http::Get('lang')),0,2);
			$this->current_language = file_exists(LANGPATH.$new_lang.'.php') ? $new_lang : $this->default_language;
		} elseif(isset($existingLangs[$list[1]] ))   {
		     $this->current_language = $list[1];			
		} else {
			if ($this->Session->Get('lang')) {
				$this->current_language = $this->Session->Get('lang');
			} else {
				if ($use_cookie) {
					if ($cookie_lang) {
						if (file_exists(LANGPATH.$cookie_lang.'.php')) {
							$this->current_language = $cookie_lang;
						}
					} else {
						$this->current_language = $this->default_language;
					}
				} else {
					$this->current_language = $this->default_language;
				}
			}
		}
		
		$this->Session->Set('lang',$this->current_language);
		
		//echo 'lang:'.$this->current_language;
		
		 	
		if ($use_cookie) Tools_Http::sendCookie ('lang',$this->current_language);
		
		
		$lng = $this->current_language;
		//include LANGPATH.'static.php';
		
		include LANGPATH.$lng.'.php';
		//include LANGPATH.$lng.'_t.php';
		
		if (!empty($LANG)) {
		  	$this->lang_array = $LANG;
			unset($LANG);
		}
		
		/* if (!empty($LANG_T)) {
			$this->lang_t_array = $LANG_T;
			unset($LANG_T);
		}  */
		
		if (!empty($STATIC_LANG)) {
			$this->static_array = $STATIC_LANG;
		}
	}
	
	public static function getInstance() {
		if (!self::$instance) {
			self::$instance = new self	();
		}
		return self::$instance;
	}
	
	public function __destruct () {
		return true;
	}

		 
	public function getCurrentLang() {

		return $this->lang_id;
	}
	
	
	public function getCurrentLanguage () {
		return $this->current_language;
	}
	
	public function Str ($str,$static=1,$arguments=array()) {
	
		//echo LANGPATH;
		
		//unset($this->lang_array);
		
		//unset($this->lang_array[$str]);
		
		if (array_key_exists($str,$this->lang_array) && !empty($this->lang_array[$str])) {
		
			return empty($arguments) ? $this->lang_array[$str] : vsprintf($this->lang_array[$str],$arguments);
		} else {
			  
			//echo "SELECT id FROM languages WHERE ".$this->lang_key." = '".$this->DB->Escape($str)."'";	
			if (!$this->DB->Count($this->DB->Exec("SELECT id FROM languages WHERE ".$this->lang_key." = '".$this->DB->Escape($str)."'"))) {
			
		 		//echo $this->lang_array[$str];	
				$this->DB->Exec("INSERT INTO languages (".$this->lang_key.",static) VALUES ('".$this->DB->Escape($str)."',".$static.")");
				$this->generateLanguageFiles();
			}  
			return empty($arguments) ? $str : vsprintf($str,$arguments);
		}
	}
	
	public function generateLanguageFiles ($lang='') {
		$langs = $lang ? array($lang) : $this->GetLanguageList();
		if (!empty($langs)) {
			foreach ($langs as $lang) {
				if ($lang != $this->lang_key) {
					$file = LANGPATH.$lang.'.php';
					$result = $this->DB->Exec("SELECT ".$this->lang_key." AS k,".$lang." AS val FROM languages");
					$rows = $this->DB->Count($result);
					$str = '<? '.Tools_Filesystem::eol;
					if ($rows) {
						for ($i=0;$i<$rows;$i++) {
							$data = $this->DB->Fetch($result);
							$str .= '$LANG[\''.str_replace("'","\'",$data['k']).'\'] = \''.str_replace("'","\'",$data['val']).'\';'.Tools_Filesystem::eol;
						}
					}
					$str .= ' ?>'.Tools_Filesystem::eol;
					
				
					Tools_Filesystem::writeFile ($file,$str,Tools_Filesystem::fs_rewrite);
					
					
					
					/* $file = LANGPATH.$lang.'_t.php';
					$result = $this->DB->Exec("SELECT * FROM languages_texts WHERE lang = '".$lang."'");
					$rows = $this->DB->Count($result);
					$str = '<? '.Tools_Filesystem::eol;
					if ($rows) {
						for ($i=0;$i<$rows;$i++) {
							$data = $this->DB->Fetch($result);
							$key = $data['type'].'/'.$data['col'].'/'.$data['objectid'];
							$str .= '$LANG_T[\''.str_replace("'","\'",$key).'\'] = \''.str_replace("'","\'",$data['translation']).'\';'.Tools_Filesystem::eol;
						}
					}
					$str .= ' ?>'.Tools_Filesystem::eol; 
					Tools_Filesystem::writeFile ($file,$str,Tools_Filesystem::fs_rewrite);  */ 
					
					
				}
			}
		}
	}  
	
	
	public function StrT ($table, $column, $objectid, $original, $lang = '' ,$strict=0) {
	   
	   $selected_lang = $lang ? $lang : $_SESSION['lang'];
       $query = 'SELECT translation FROM languages_texts WHERE lang = "'.$selected_lang.'" AND type="'.$table.'" AND objectid="'.$objectid.'" AND col="'.$column.'" ';
       
       //echo $query.'<br>';
       
	   $row_query = $this->DB->Exec($query);
	   list($trans) = $this->DB->FetchRow($row_query);
	   // $this->sql_count++;
		//echo 'From db '.$table.'/'.$column.'/'.$objectid.'<br>';	
		
		//$str = $table.'/'.$column.'/'.$objectid;
		//$this->lang_t_array[$str]=$trans;
			
		if($trans) return $trans;			
		if($strict) return $trans; 
				
		return $original;
	
	}
	
/* 	public function StrT ($table, $column, $objectid, $original, $lang = '' ,$strict=0) {
	   
	   $selected_lang = $lang ? $lang : $_SESSION['lang'];
	   //print_r($_SESSION);
	   
	
			
		$str = '';
		//$str = $table.'/'.$column.'/'.$objectid; // masiivam
        //TODO!
		if (array_key_exists($str,$this->lang_t_array) && !empty($this->lang_t_array[$str])) {
			if (!empty($this->lang_t_array[$str])) {
			
				return $this->lang_t_array[$str];
			} else {

                //echo 'SELECT translation FROM languages_texts WHERE lang = "'.$selected_lang.'" AND type="'.$table.'" AND objectid="'.$objectid.'" AND col="'.$column.'" ';
				  $row_query = this->db->Exec('SELECT translation FROM languages_texts WHERE lang = "'.$selected_lang.'" AND type="'.$table.'" AND objectid="'.$objectid.'" AND col="'.$column.'" ');
				list($trans) = $this->DB->FetchRow($row_query);
		
				if($trans)
					return $trans;
				else					
					return $original;
			}
				
		} else {
			
			$row_query = this->db->Exec('SELECT translation FROM languages_texts WHERE lang = "'.$selected_lang.'" AND type="'.$table.'" AND objectid="'.$objectid.'" AND col="'.$column.'" ');
			list($trans) = $this->DB->FetchRow($row_query);
			
			//echo 'From db '.$table.'/'.$column.'/'.$objectid.'<br>';	
		
			//$str = $table.'/'.$column.'/'.$objectid;
			//$this->lang_t_array[$str]=$trans;
			
			if($trans) return $trans;			
			if($strict) return $trans; 
				
			return $original;
		}
	}     */
	
		public function StrT_lang ($table, $column, $objectid, $original,$lang) {
	   
		if($objectid) {
		
		
			$query = 'SELECT translation FROM languages_texts WHERE lang = "'.$lang.'" AND type="'.$table.'" AND objectid="'.$objectid.'" AND col="'.$column.'" ';
			
			 //echo $query;
			$row_query = $this->DB->Exec($query);
			list($trans) = $this->DB->FetchRow($row_query);
			
			if(!$trans) 
			 $trans =  $original;
			
			$trans = htmlspecialchars($trans);
			
			//echo $trans;
			
			return $trans; 
		}
	}
	
	public function getLanguageList ($active_only=false) {
		$langs = array();
		$result = $this->DB->Exec("SHOW COLUMNS FROM languages");
		$rows = $this->DB->Count($result);
		if ($rows) {
			for ($i=0;$i<$rows;$i++) {
				$l = $this->DB->Fetch ($result);
				if ($l['Field']!='id' && $l['Field'] != $this->lang_key && $l['Field'] != 'static') {
					if (!$active_only || ($active_only&&$this->getLanguageStatus($l['Field'])))
						array_push ($langs, $l['Field']);
				}
			}
		}
		return $langs;
	}
	
	public function addText ($table, $column, $id) {
		$langs = $this -> getLanguageList();
		foreach ($langs as $lang) {
			//if ($lang != $this -> default_language) {
				$this -> DB -> Exec("INSERT INTO languages_texts SET type = '".$table."', objectid = ".$id.", lang = '".$lang."', col = '".$column."'");
			//}
		}
	}
	
	public function addValue ($table, $column, $id,$lang,$value) {

	
		$this -> DB -> Exec("INSERT INTO languages_texts (type,objectid,lang,col,translation) values ('".$table."',".$id.",'".$lang."','".$column."','".$value."')  ON DUPLICATE KEY UPDATE  translation='".$value."' ");
		
	}
	
		public function removeValue ($table, $column, $id) {

		$this -> DB -> Exec("DELETE FROM languages_texts WHERE type =".$table."' AND objectid=".$id."  AND col='".$column."' ");
		
	}
	
	public function createLanguage ($code, $name) {
		if (!$code) {
			$this->setLastError(self::err_no_lang_code);
			return false;
		}
		
		if (!$name) {
			$this->setLastError(self::err_no_lang_name);
			return false;
		}
		
		if (strlen($code)!=2){
			$this->setLastError(self::err_incorrect_code_len);
			return false;
		}
		
		$lngs = $this->getLanguageList();
		if (in_array($code, $lngs)) {
			$this->setLastError(self::err_code_exists);
			return false;
		}
		
		if (!ctype_alpha($code)) {
			$this->setLastError(self::err_code_invalid);
			return false;
		}
		
		$code=substr($code,0,2);
		$res = $this->DB->Exec ("ALTER TABLE languages ADD column ".strtolower($code)." text");
		$this->generateLanguageFiles();
		$this->Config->Set('lang_def_'.$code,$name);
		return true;
	}
	
	public function removeLanguage ($name) {
		$file = LANGPATH.$name.'.php';
		if (file_exists($file)) {
			$get = $this->DB->Exec ("ALTER TABLE languages DROP column ".$name);
			$this->DB->Exec("DELETE FROM languages_texts WHERE lang = '".$name."' ");
			unlink ($file);
		}
	}

	
	public function removeRow ($ids) {
		$this->DB->Exec ("DELETE FROM languages WHERE id ".(is_array($ids) ? "IN (".implode(',',$ids).")":"=".$ids));
		$this->generateLanguageFiles();
	}
	
	public function getLangName ($code) {
		return $this->Config->Get('lang_def_'.$code)?$this->Config->Get('lang_def_'.$code):strtoupper($code);
	}
	
	public function Translate ($id, $lang, $translation) {
		$this->DB->Exec ("UPDATE languages SET ".$lang." = '".$this->DB->Escape($translation)."' WHERE id = ".$id);
		//$this->generateLanguageFiles($lang);
	}
	
	public function TranslateText ($id, $translation) {
		$this->DB->Exec ("UPDATE languages_texts SET translation = '".$this->DB->Escape($translation)."' WHERE id = ".$id);
		//$this->generateLanguageFiles($lang);
	}
	
	public function setDefaultLanguage ($lang) {
		if (in_array($lang, $this->getLanguageList())) {
			$this->Config->Set('DEFAULT_SITE_LANG',$lang);
			return true;
		} else return false;
	}
	
	public function setLanguageStatus ($lang, $status) {
		if (in_array($lang, $this->getLanguageList())) {
			$this->Config->Set('LANG_'.strtoupper($lang).'_ACTIVE',intval($status));
		}
	}
	
	public function getLanguage